/*
 * pi3's Linux kernel Runtime Guard
 *
 * Component:
 *  - Intercept cap_task_prctl function
 *
 * Notes:
 *  - Exploit Detection features needs to whitelist process which
 *    legitimately increases their privileges (e.g. 'su', 'sudo', etc.)
 *
 * Caveats:
 *  - None
 *
 * Timeline:
 *  - Created: 05.XII.2017
 *
 * Author:
 *  - Adam 'pi3' Zabrocki (http://pi3.com.pl)
 *
 */

#ifndef P_LKRG_EXPLOIT_DETECTION_CAP_TASK_PRCTL_H
#define P_LKRG_EXPLOIT_DETECTION_CAP_TASK_PRCTL_H

/* per-instance private data */
struct p_cap_task_prctl_data {
    ktime_t entry_stamp;
};


int p_cap_task_prctl_ret(struct kretprobe_instance *ri, struct pt_regs *p_regs);
int p_cap_task_prctl_entry(struct kretprobe_instance *p_ri, struct pt_regs *p_regs);
int p_install_cap_task_prctl_hook(void);
void p_uninstall_cap_task_prctl_hook(void);

#endif
