/*
 * pi3's Linux kernel Runtime Guard
 *
 * Component:
 *  - Intercept keyctl syscall
 *
 * Notes:
 *  - Exploit Detection features needs to whitelist process which
 *    legitimately increases or changes their privileges structure.
 *
 * Caveats:
 *  - Keyring support
 *
 * Timeline:
 *  - Created: 17.I.2018
 *
 * Author:
 *  - Adam 'pi3' Zabrocki (http://pi3.com.pl)
 *
 */

#ifndef P_LKRG_EXPLOIT_DETECTION_SYS_KEYCTL_H
#define P_LKRG_EXPLOIT_DETECTION_SYS_KEYCTL_H

/* per-instance private data */
struct p_sys_keyctl_data {
    ktime_t entry_stamp;
};


int p_sys_keyctl_ret(struct kretprobe_instance *ri, struct pt_regs *p_regs);
int p_sys_keyctl_entry(struct kretprobe_instance *p_ri, struct pt_regs *p_regs);
int p_install_sys_keyctl_hook(void);
void p_uninstall_sys_keyctl_hook(void);

#endif
