/*
 * pi3's Linux kernel Runtime Guard
 *
 * Component:
 *  - Intercept '____queue_work' function
 *
 * Notes:
 *  - Enforce Exploit Detection CFI
 *
 * Caveats:
 *  - None
 *
 * Timeline:
 *  - Created: 20.XI.2018
 *
 * Author:
 *  - Adam 'pi3' Zabrocki (http://pi3.com.pl)
 *
 */

#include "../../../../../p_lkrg_main.h"


char p_pcfi___queue_work_kretprobe_state = 0x0;

static struct kretprobe p_pcfi___queue_work_kretprobe = {
    .kp.symbol_name = "__queue_work",
    .handler = p_pcfi___queue_work_ret,
    .entry_handler = p_pcfi___queue_work_entry_extra,
    .data_size = sizeof(struct p_pcfi___queue_work_data),
    /* Probe up to 40 instances concurrently. */
    .maxactive = 40,
};

/*
 * x86-64 syscall ABI:
 *  *rax - syscall_number
 *    rdi - 1st argument
 *    rsi - 2nd argument
 *    rdx - 3rd argument
 *    rcx - 4th argument
 *
 *    r8  - 5th one
 *    r9  - 6th one
 */

int p_pcfi___queue_work_entry_noextra(struct kretprobe_instance *p_ri, struct pt_regs *p_regs) {

//   struct p_ed_process *p_tmp;

// STRONG_DEBUG
   p_debug_kprobe_log(
          "Entering function <p_pcfi___queue_work_entry>\n");

   p_ed_pcfi_validate_cpu(1);

// STRONG_DEBUG
   p_debug_kprobe_log(
          "Leaving function <p_pcfi___queue_work_entry>\n");

   return 0x0;
}

int p_pcfi___queue_work_entry_extra(struct kretprobe_instance *p_ri, struct pt_regs *p_regs) {

//   struct p_ed_process *p_tmp;

// STRONG_DEBUG
   p_debug_kprobe_log(
          "Entering function <p_pcfi___queue_work_entry>\n");

   p_ed_pcfi_validate_cpu_extra(1);

// STRONG_DEBUG
   p_debug_kprobe_log(
          "Leaving function <p_pcfi___queue_work_entry>\n");

   return 0x0;
}


int p_pcfi___queue_work_ret(struct kretprobe_instance *p_ri, struct pt_regs *p_regs) {

// STRONG_DEBUG
   p_debug_kprobe_log(
          "Entering function <p_pcfi___queue_work_ret>\n");

//   p_ed_enforce_validation();

// STRONG_DEBUG
   p_debug_kprobe_log(
          "Leaving function <p_pcfi___queue_work_ret>\n");

   return 0x0;
}


int p_install_pcfi___queue_work_hook(void) {

   int p_ret;

// STRONG_DEBUG
   p_debug_log(P_LKRG_STRONG_DBG,
          "Entering function <p_install_pcfi___queue_work_hook>\n");

   if (unlikely(!p_pcfi_CPU_flags)) {
      p_pcfi___queue_work_kretprobe.entry_handler = p_pcfi___queue_work_entry_noextra;
   }

   if ( (p_ret = register_kretprobe(&p_pcfi___queue_work_kretprobe)) < 0) {
      p_print_log(P_LKRG_ERR, "[kretprobe] register_kretprobe() for <%s> failed! [err=%d]\n",
                  p_pcfi___queue_work_kretprobe.kp.symbol_name,
                  p_ret);
      goto p_install_pcfi___queue_work_hook_out;
   }
   p_print_log(P_LKRG_INFO, "Planted [kretprobe] <%s> at: %p\n",
               p_pcfi___queue_work_kretprobe.kp.symbol_name,
               p_pcfi___queue_work_kretprobe.kp.addr);
   p_pcfi___queue_work_kretprobe_state = 0x1;

//   p_ret = 0x0; <- should be 0x0 anyway...

p_install_pcfi___queue_work_hook_out:

// STRONG_DEBUG
   p_debug_log(P_LKRG_STRONG_DBG,
          "Leaving function <p_install_pcfi___queue_work_hook> (p_ret => %d)\n",p_ret);

   return p_ret;
}


void p_uninstall_pcfi___queue_work_hook(void) {

// STRONG_DEBUG
   p_debug_log(P_LKRG_STRONG_DBG,
          "Entering function <p_uninstall_pcfi___queue_work_hook>\n");

   if (!p_pcfi___queue_work_kretprobe_state) {
      p_print_log(P_LKRG_INFO, "[kretprobe] <%s> at 0x%p is NOT installed\n",
                  p_pcfi___queue_work_kretprobe.kp.symbol_name,
                  p_pcfi___queue_work_kretprobe.kp.addr);
   } else {
      unregister_kretprobe(&p_pcfi___queue_work_kretprobe);
      p_print_log(P_LKRG_INFO, "Removing [kretprobe] <%s> at 0x%p nmissed[%d]\n",
                  p_pcfi___queue_work_kretprobe.kp.symbol_name,
                  p_pcfi___queue_work_kretprobe.kp.addr,
                  p_pcfi___queue_work_kretprobe.nmissed);
      p_pcfi___queue_work_kretprobe_state = 0x0;
   }

// STRONG_DEBUG
   p_debug_log(P_LKRG_STRONG_DBG,
          "Leaving function <p_uninstall_pcfi___queue_work_hook>\n");
}
