/*
 * pi3's Linux kernel Runtime Guard
 *
 * Component:
 *  - Intercept do_init_module function called from the syscalls:
 *     *) init_module
 *     *) finit_module
 *
 * Notes:
 *  - Enforce Exploit Detection validation
 *
 * Caveats:
 *  - On kernel < 4.0 you can't intercept do_init_module function
 *    and each *init_module syscall must be intercepted individually.
 *    In that case, this module will intercept sys_init_module syscall
 *
 * Timeline:
 *  - Created: 04.X.2017
 *
 * Author:
 *  - Adam 'pi3' Zabrocki (http://pi3.com.pl)
 *
 */

#ifndef P_LKRG_EXPLOIT_DETECTION_DO_INIT_MODULE_H
#define P_LKRG_EXPLOIT_DETECTION_DO_INIT_MODULE_H

/* per-instance private data */
struct p_do_init_module_data {
    ktime_t entry_stamp;
};


int p_do_init_module_ret(struct kretprobe_instance *ri, struct pt_regs *p_regs);
int p_do_init_module_entry(struct kretprobe_instance *p_ri, struct pt_regs *p_regs);
int p_install_do_init_module_hook(void);
void p_uninstall_do_init_module_hook(void);

#endif
