/*
 * pi3's Linux kernel Runtime Guard
 *
 * Component:
 *  - Intercept delete_module syscall
 *
 * Notes:
 *  - Enforce Exploit Detection validation
 *
 * Caveats:
 *  - None
 *
 * Timeline:
 *  - Created: 04.X.2017
 *
 * Author:
 *  - Adam 'pi3' Zabrocki (http://pi3.com.pl)
 *
 */

#ifndef P_LKRG_EXPLOIT_DETECTION_SYS_DELETE_MODULE_H
#define P_LKRG_EXPLOIT_DETECTION_SYS_DELETE_MODULE_H

/* per-instance private data */
struct p_sys_delete_module_data {
    ktime_t entry_stamp;
};


int p_sys_delete_module_ret(struct kretprobe_instance *ri, struct pt_regs *p_regs);
int p_sys_delete_module_entry(struct kretprobe_instance *p_ri, struct pt_regs *p_regs);
int p_install_sys_delete_module_hook(void);
void p_uninstall_sys_delete_module_hook(void);

#endif
