/*
 * pi3's Linux kernel Runtime Guard
 *
 * Component:
 *  - Intercept execve syscall
 *
 * Notes:
 *  - We are maintianing Red-Black tree of pid's for Exploit Detection feature.
 *    When process calls execve, we need to update RB tree.
 *
 * Caveats:
 *  - None
 *
 * Timeline:
 *  - Created: 18.IX.2017
 *
 * Author:
 *  - Adam 'pi3' Zabrocki (http://pi3.com.pl)
 *
 */

#ifndef P_LKRG_EXPLOIT_DETECTION_SYS_EXECVE_H
#define P_LKRG_EXPLOIT_DETECTION_SYS_EXECVE_H

#define P_MAX_PATH PATH_MAX + 0x20 /* For weirdos used by d_path */


/* per-instance private data */
struct p_sys_execve_data {
    ktime_t entry_stamp;
};


struct inode *p_get_inode_from_task(struct task_struct *p_arg);

int p_sys_execve_ret(struct kretprobe_instance *ri, struct pt_regs *p_regs);
int p_sys_execve_entry(struct kretprobe_instance *p_ri, struct pt_regs *p_regs);
int p_install_sys_execve_hook(void);
void p_uninstall_sys_execve_hook(void);

#endif
