/*
 * pi3's Linux kernel Runtime Guard
 *
 * Component:
 *  - Intercept execveat syscall
 *
 * Notes:
 *  - We are maintianing Red-Black tree of pid's for Exploit Detection feature.
 *    When process calls execve, we need to update RB tree.
 *
 * Caveats:
 *  - None
 *
 * Timeline:
 *  - Created: 02.I.2018
 *
 * Author:
 *  - Adam 'pi3' Zabrocki (http://pi3.com.pl)
 *
 */

#if LINUX_VERSION_CODE >= KERNEL_VERSION(3,19,0)

#ifndef P_LKRG_EXPLOIT_DETECTION_SYS_EXECVEAT_H
#define P_LKRG_EXPLOIT_DETECTION_SYS_EXECVEAT_H

/* per-instance private data */
struct p_sys_execveat_data {
    ktime_t entry_stamp;
};

int p_sys_execveat_ret(struct kretprobe_instance *ri, struct pt_regs *p_regs);
int p_sys_execveat_entry(struct kretprobe_instance *p_ri, struct pt_regs *p_regs);
int p_install_sys_execveat_hook(void);
void p_uninstall_sys_execveat_hook(void);

#endif

#endif
