/*
 * pi3's Linux kernel Runtime Guard
 *
 * Component:
 *  On kernel < 4.0 you can't intercept do_init_module function
 *  and each *init_module syscall must be intercepted individually.
 *  This module intercepts sys_finit_module
 *
 * Notes:
 *  - Enforce Exploit Detection validation
 *
 * Caveats:
 *  - None
 *
 * Timeline:
 *  - Created: 12.XII.2017
 *
 * Author:
 *  - Adam 'pi3' Zabrocki (http://pi3.com.pl)
 *
 */

//#if LINUX_VERSION_CODE < KERNEL_VERSION(4,0,0)

#ifndef P_LKRG_EXPLOIT_DETECTION_SYS_FINIT_MODULE_H
#define P_LKRG_EXPLOIT_DETECTION_SYS_FINIT_MODULE_H

/* per-instance private data */
struct p_sys_finit_module_data {
    ktime_t entry_stamp;
};


int p_sys_finit_module_ret(struct kretprobe_instance *ri, struct pt_regs *p_regs);
int p_sys_finit_module_entry(struct kretprobe_instance *p_ri, struct pt_regs *p_regs);
int p_install_sys_finit_module_hook(void);
void p_uninstall_sys_finit_module_hook(void);

#endif

//#endif
