/*
 * pi3's Linux kernel Runtime Guard
 *
 * Component:
 *  - Intercept userns_install function
 *
 * Notes:
 *  - Exploit Detection features needs to whitelist process which
 *    legitimately increases their privileges (e.g. 'su', 'sudo', etc.)
 *
 * Caveats:
 *  - None
 *
 * Timeline:
 *  - Created: 05.XII.2017
 *
 * Author:
 *  - Adam 'pi3' Zabrocki (http://pi3.com.pl)
 *
 */

#ifndef P_LKRG_EXPLOIT_DETECTION_USERNS_INSTALL_H
#define P_LKRG_EXPLOIT_DETECTION_USERNS_INSTALL_H

/* per-instance private data */
struct p_userns_install_data {
    ktime_t entry_stamp;
};


int p_userns_install_ret(struct kretprobe_instance *ri, struct pt_regs *p_regs);
int p_userns_install_entry(struct kretprobe_instance *p_ri, struct pt_regs *p_regs);
int p_install_userns_install_hook(void);
void p_uninstall_userns_install_hook(void);

#endif
